.nolist
include \masm32\include\masm32rt.inc		; the imul flag problem is in GetPercentInt
.686
.xmm
include \masm32\macros\timers.asm	; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]

Algo MACRO arg
	finit
	REPEAT 8
	;	fldpi
	ENDM
	invoke Sleep, SleepMs
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
	REPEAT 64
		invoke &arg, 85899346, 50
	ENDM
	counter_end
	shr eax, 6
	print str$(eax), 9, "cycles for &arg", 13, 10
ENDM

CodeSize MACRO algo, extra	; macro modified from MasmBasic
  mov eax, offset &algo&_e
  sub eax, offset &algo&_s
  ifnb <extra>
	add eax, extra
  endif
  print str$(eax), 9, "bytes for &algo&, result="
	finit
	REPEAT 8
		fldpi
	ENDM
  invoke &algo, 12345678, 55	; expected 6790122.9
  print str$(eax), 13, 10
ENDM

.code

GetPercent_s:
GetPercent proc source:DWORD, percent:DWORD	; the original from m32\getpcnt.asm
    LOCAL var1:DWORD
    mov var1, 100   ; to divide by 100
    fild source     ; load source integer
    fild var1       ; load 100
    fdiv            ; divide source by 100
    fild percent    ; load required percentage
    fmul            ; multiply 1% by required percentage
    fistp var1      ; store result in variable
    mov eax, var1
    ret
GetPercent endp
GetPercent_e:

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
GetPercent2c_s:
GetPercent2c proc source:DWORD, percent:DWORD	; the original from m32\getpcnt.asm, [url=http://www.masm32.com/board/index.php?topic=15263.msg124153#msg124153]with mods from Hutch[/url]
;		ffree st(7)	; 		### needed to avoid problems with the FPU (commented in 'cheat' version) ###
    fild DWORD PTR [esp+8]  ; load percent
;		ffree st(7)	; 		### needed to avoid problems with the FPU ###
    fld10 0.01              ; load reciprocal of 100		### +12 bytes for code size ###
    fmul                    ; mul by reciprocal = div by 100
    fild DWORD PTR [esp+4]  ; load the source
    fmul                    ; multiply by previous result
    fistp DWORD PTR [esp+8] ; pop FP stack and store result in stack variable
    mov eax, [esp+8]        ; write result to EAX for return value
    ret 8
GetPercent2c endp
GetPercent2c_e:

GetPercent2nc_s:
GetPercent2nc proc source:DWORD, percent:DWORD	; the original from m32\getpcnt.asm, with mods from Hutch
		ffree st(7)	; 		### needed to avoid problems with the FPU ###
    fild DWORD PTR [esp+8]  ; load percent
		ffree st(7)	; 		### needed to avoid problems with the FPU ###
    fld10 0.01              ; load reciprocal of 100		### +12 bytes for code size ###
    fmul                    ; mul by reciprocal = div by 100
    fild DWORD PTR [esp+4]  ; load the source
    fmul                    ; multiply by previous result
    fistp DWORD PTR [esp+8] ; pop FP stack and store result in stack variable
    mov eax, [esp+8]        ; write result to EAX for return value
    ret 8
GetPercent2nc endp
GetPercent2nc_e:

GetPercentJJ1_s:
GPJ001	REAL10 0.01
GetPercentJJ1 proc source:DWORD, percent:DWORD
	if 1
		ffree st(7)
	fld GPJ001	; mul source by 0.01, i.e. divide by 100
	fimul dword ptr [esp+4]	; load source integer
	fimul dword ptr [esp+8]	; multiply 1% by required percentage
	fistp dword ptr [esp+4]	; store result on stack
	mov eax, dword ptr [esp+4]	; 4 bytes, 37 total, 2 cycles faster on P4
	else
		ffree st(7)
		push eax
	fld GPJ001	; mul source by 0.01, i.e. divide by 100
	fimul dword ptr [esp+8]	; load source integer
	fimul dword ptr [esp+12]	; multiply 1% by required percentage
	fistp dword ptr [esp]	; store result on stack
	pop eax	; return in eax
	endif
	ret 8
GetPercentJJ1 endp
GetPercentJJ1_e:

GetPercentJJ2_s:
GPJ002	REAL8 0.01	; 8 bytes is enough, results are exact
GetPercentJJ2 proc source:DWORD, percent:DWORD
		push eax
		ffree st(7)
	fild dword ptr [esp+8]	; load source integer
	fimul dword ptr [esp+12]	; multiply 1% by required percentage
	fmul GPJ002	; multiply with 0.01, i.e. divide source by 100
	fistp dword ptr [esp]	; store result on stack
	pop eax	; return in eax
	ret 8
GetPercentJJ2 endp
GetPercentJJ2_e:

GetPercentEtalone proc source:DWORD, padd:DWORD, percent:DWORD, padd2:DWORD
	fild qword ptr [esp+4]
	fild qword ptr [esp+4+8]
	fmulp st(1),st(0)
	fmul GPJ002
	fistp qword ptr [esp+4]
	mov eax,[esp+4]
	ret 16
GetPercentEtalone endp


align 16
AxGetPercentInt_s:
AxGetPercentInt proc source:DWORD, percent:DWORD
		;int 3

		mov eax,[esp+4]
		
		if 0
		imul edx,[esp+8],28F5C29h
		jl @F
		else
		mov edx,[esp+8]
		cmp edx,99
		ja @F
		imul edx,28F5C29h
		endif

		mul edx
		mov eax,edx
		shr edx,32-2
		sub eax,edx
		@@:
		ret 8			
				
AxGetPercentInt endp
AxGetPercentInt_e:



if 0
; [url=http://www.masm32.com/board/index.php?topic=5821.msg43263#msg43263]MichaelW[/url]: The problem with these methods is that they do not duplicate the results of DIV over the full range of values.

  if 1
	mov eax, [esp+4]			; source
	xor edi, edi
	test eax, 0FF000000h
	.if Zero?
		imul dword ptr [esp+8]		; low source, multiply first with percent, then div 100
		inc eax
		mov edx, 0a3d70a3dh		; Agner Fog
		mul edx
		shr edx, 6
		mov eax, edx
		ret 8
	.elseif Sign?
		@@:
		inc edi		; case 1
;		int 3
		imul dword ptr [esp+8]	; percent
		push 100
		idiv dword ptr [esp]		; yields correct result
		pop edx
		ret 8
	.else
		add edi, 2
		jmp @B
;		int 3
		shr eax, 2					; divide by 4, first step
		inc eax						; high source, so div 100 first
		mov edx, 2748779069		; Agner Fog magic divider
		mul edx
		shr edx, 4
		mov eax, edx
		imul dword ptr [esp+8]		; chokes for negative source, also with imul
		ret 8
	.endif
  else
	mov eax, [esp+4]	; source
	imul dword ptr [esp+8]	; percent
	push 100
	idiv dword ptr [esp]		; yields correct result for imul+idiv
	pop edx
  endif

endif


GetPercentJJ4_s:
GPJ004	REAL8 0.01
GetPercentJJ4 proc source:DWORD, percent:DWORD
		mov eax, [esp+4]	; source
		imul dword ptr [esp+8]	; percent
		push eax
	fild dword ptr [esp]	; load source integer
	fmul GPJ004	; divide source by 100
	fistp dword ptr [esp]	; store result on stack
	pop eax	; return in eax
		ret 8
GetPercentJJ4 endp
GetPercentJJ4_e:

GetPercentSSE_s:
GPJ005	REAL8 0.01
GetPercentSSE proc source:DWORD, percent:DWORD
	cvtsi2sd xmm0, dword ptr [esp+4]		; source
	cvtsi2sd xmm1, dword ptr [esp+8]		; percent
	mulsd xmm0, xmm1
	mulsd xmm0, GPJ005		; multiply with 0.01, i.e. divide source by 100
	cvtsd2si eax, xmm0
	ret 8		; 11 cycles
GetPercentSSE endp
GetPercentSSE_e:

GetPercentSSEs_s:
GPJ005s	REAL8 0.01
GetPercentSSEs proc source:DWORD, percent:DWORD
;	xorps xmm0, xmm0
;	movaps xmm1, xmm0	; no effect
	movd xmm0, dword ptr [esp+4]	; source
	movd xmm1, dword ptr [esp+8]	; percent
;	int 3	; OPT_Olly 2
	pmuludq xmm0, xmm1			; source * percent, OK (pm xmm0, qword ptr [esp+8] possible but slow)
	MakeSlow = 1
	if MakeSlow						; first branch: result is correct but >200 cycles
		mulsd xmm0, GPJ005s		; multiply with 0.01, i.e. divide source by 100 - SLOOOOOOW ###
		movd eax, xmm0
	else							; second branch: result correct, 27 cycles
		cvtdq2pd xmm0, xmm0		; convert integer to float (Convert  Packed Doubleword Integers to Packed Double-Precision Floating-Point Values)
		mulsd xmm0, GPJ005s		; multiply with 0.01, i.e. divide source by 100 - fast
		cvttsd2si eax, xmm0
	endif
	ret 8		; 259 or 348 cycles
GetPercentSSEs endp
GetPercentSSEs_e:

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef
start:	push 1
	call ShowCpu	; print brand string and SSE level

;	CodeSize GetPercentInt
;	inkey "OK"
;	exit
	m2m esi, 1
	mov esi, 1;07FFF0000h
;	mov esi, 07FFFFFFFh
;	inc esi
	call ChkPrecision
;		invoke GetPercentSSE, 222222222, 50
;		print str$(eax), " - should be 111111111", 13, 10

	SleepMs =	50	; test if anything changes when changing this
	LOOP_COUNT =	100000	; One Mio would be a typical value
	REPEAT 2
		Algo GetPercentSSE
		Algo GetPercent
		Algo GetPercent2c
		Algo GetPercent2nc
		Algo GetPercentJJ1
		Algo GetPercentJJ2
		Algo AxGetPercentInt
;		Algo GetPercentJJ4
;		Algo GetPercentSSEs	; slow version
		print chr$(13, 10)
	ENDM
	if 1
	print "Code sizes:", 13, 10
	CodeSize GetPercentSSE
	CodeSize GetPercent
	CodeSize GetPercent2c, 12
	CodeSize GetPercent2nc, 12
	CodeSize GetPercentJJ1
	CodeSize GetPercentJJ2
	CodeSize AxGetPercentInt
;	CodeSize GetPercentJJ4
;	CodeSize GetPercentSSEs
	endif
	inkey chr$(13, 10, "--- ok ---", 13)
	exit


ChkPrecision proc
;ret
.data?
ct1	dd ?
ct2	dd ?
.code
  .Repeat
	xor ebx, ebx
	.Repeat
		invoke GetPercentEtalone, esi,0,ebx,0
		push eax
		invoke AxGetPercentInt, esi, ebx
		pop edx
		sub edx, eax
		.if !Zero?
			.if sdword ptr edx>1 || sdword ptr edx<-1	;42949673
				print str$(edx), " for "
				print hex$(esi), "/"
				print str$(ebx), ", case "
				inkey str$(edi), 13, 10
				int 3
				invoke AxGetPercentInt, esi, ebx
			.endif
		.endif
		inc ebx
	.Until ebx>100
	add esi, 10000
  .Until esi>4294960000	; 4294967296
;  print str$(ct1), "/"
;  print str$(ct2), 13, 10
  ret
ChkPrecision endp

ShowCpu proc	; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h	; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h		; cpuid 1
  xor ebx, ebx		; CpuSSE
  xor esi, esi		; add zero plus the carry flag
  bt edx, 25		; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26		; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi		; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9			; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]	; dec mode in stack
  .if Zero?
	mov edi, esp	; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	.if byte ptr [edi]<32
		print chr$("pre-P4")
	.else
		print edi	; CpuBrand
	.endif
	.if ebx
		print chr$(32, 40, "SSE")	; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10	; 41=)
	.endif
  .endif
  add esp, 80		; discard brand buffer (after printing!)
  mov [esp+32-4], ebx	; move ebx into eax stack position - returns eax to main for further use
  ifdef MbBufferInit
	call MbBufferInit
  endif
  popad
  ret 4
ShowCpu endp

end start

RichMasm options:

OPT_Tmp2Asm	1
OPT_Assembler	ml
OPT_Wait	0

Assume that you want to divide by 100.
100 = 1100100B.
w = 32.
b = (number of significant binary digits) - 1 = 6
r = 32+6 = 38
f = 238 / 100 = 2748779069.44 = ...(hexadecimal)
The fractional part is smaller than a half: use case B.
Round f down to 2748779069 aka 0A3D70A3Dh.
result = ((x+1) * f) SHR r

The following code divides EAX by 5 and returns the result in EDX:
; Example 16.5a. Divide unsigned integer by 5
mov edx, 0CCCCCCCDH
mul edx
shr edx, 2

Assume that you want to divide by 25.
25 = 11001B.
w = 32.
b = (number of significant binary digits) - 1 = 4
r = 32+4 = 36
f = 236 / 25 = 2748779069.44 = ...(hexadecimal)
The fractional part is smaller than a half: use case B.
Round f down to 2748779069 aka A3D70A3D.
result = ((x+1) * f) SHR r


Assume that you want to divide by 5.
5 = 101B.
w = 32.
b = (number of significant binary digits) - 1 = 2
r = 32+2 = 34
f = 234 / 5 = 3435973836.8 = 0CCCCCCCC.CCC...(hexadecimal)
The fractional part is greater than a half: use case C.
Round f up to 0CCCCCCCDH.
The following code divides EAX by 5 and returns the result in EDX:
; Example 16.5a. Divide unsigned integer by 5
mov edx, 0CCCCCCCDH
mul edx
shr edx, 2

